#include <cstdlib>
#include <ctime>
#include <fstream>
#include <random>

int main( )
{
   std::default_random_engine gen(std::time(nullptr));

   const auto D = 200;
   const auto C = 5 + gen( ) % 15;
   const auto A = 50;

   std::uniform_int_distribution<std::uint32_t> dist(0, D - 1);
   char tablero[D][D] = { };

   for (int i = 0; i < C; ++i) {
      int x = dist(gen) % D;
      int y = dist(gen) % D;
      int n = dist(gen) % 25 + 10;

      for (int j = 0; j < n; ++j) {
         int dx = dist(gen) % 20;
         int dy = dist(gen) % 20;

         int xx = std::max(0, std::min(D - 1, x + dx));
         int yy = std::max(0, std::min(D - 1, y + dy));

         if (xx != x + dx || yy != y + dy) {
            continue;
         }

         tablero[xx][yy] = i + 'A';
      }
   }

   for (int i = 0; i < A; ++i) {
      tablero[dist(gen) % D][dist(gen) % D] = 'X';
   }

   std::ofstream ofs1("mapa_original.txt");
   std::ofstream ofs2("mapa_entrada.txt");

   ofs2 << 200 << '\n';

   for (int i = 0; i < D; ++i) {
      for (int j = 0; j < D; ++j) {
         if (tablero[i][j] != '\0') {
            ofs1 << tablero[i][j];
            ofs2 << '*';
         }
         else {
            ofs1 << '.';
            ofs2 << '.';
         }
      }

      ofs1 << '\n';
      ofs2 << '\n';
   }
}
